#!c:\\python\\python.exe

#
# pedram amini <pamini@tippingpoint.com>
#
# this was a really half assed fuzz. someone should take it further, see my notes in the requests file for more info.
#

from sulley   import *
from requests import smil
import pgraph
import time

########################################################################################################################

class connection (pgraph.edge.edge):
    def __init__ (self, src, dst, callback=None):
        pgraph.edge.edge.__init__(self, src, dst)
        self.callback = callback

class session_file (pgraph.graph):
    def __init__ (self, session_filename=None, skip=0, sleep_time=1.0, log_level=2, proto="tcp", restart_interval=0, timeout=5.0, web_port=26000, crash_threshold=3):
        pgraph.graph.__init__(self)
        self.root       = pgraph.node()
        self.root.name  = "__ROOT_NODE__"
        self.root.label = self.root.name
        self.last_recv  = None
        self.add_node(self.root)
    def log (self, msg, level=1):
        print "[%s] %s" % (time.strftime("%I:%M.%S"), msg)
    def add_node (self, node):
        node.number = len(self.nodes)
        node.id     = len(self.nodes)
        if not self.nodes.has_key(node.id):
            self.nodes[node.id] = node
        return self
    def connect (self, src, dst=None, callback=None):
        if not dst:
            dst = src
            src = self.root
        if type(src) is str:
            src = self.find_node("name", src)
        if type(dst) is str:
            dst = self.find_node("name", dst)
        if src != self.root and not self.find_node("name", src.name):
            self.add_node(src)
        if not self.find_node("name", dst.name):
            self.add_node(dst)
        edge = connection(src.id, dst.id, callback)
        self.add_edge(edge)
        return edge
    def num_mutations (self, this_node=None, path=[]):
        if not this_node:
            this_node                = self.root
            self.total_num_mutations = 0
        for edge in self.edges_from(this_node.id):
            next_node                 = self.nodes[edge.dst]
            self.total_num_mutations += next_node.num_mutations()
            if edge.src != self.root.id:
                path.append(edge)
            self.num_mutations(next_node, path)
        if path:
            path.pop()
        return self.total_num_mutations
    def server_init (self):
        self.total_mutant_index  = 0
        self.total_num_mutations = self.num_mutations()
    def fuzz (self, this_node=None, path=[]):
        if not this_node:
            if not self.edges_from(self.root.id):
                raise sex.error("NO REQUESTS SPECIFIED IN SESSION")
            this_node = self.root
            try:    self.server_init()
            except: return
        for edge in self.edges_from(this_node.id):
            self.fuzz_node = self.nodes[edge.dst]
            num_mutations  = self.fuzz_node.num_mutations()
            if edge.src != self.root.id:
                path.append(edge)
            current_path  = " -> ".join([self.nodes[e.src].name for e in path])
            current_path += " -> %s" % self.fuzz_node.name
            self.log("current fuzz path: %s" % current_path, 2)
            self.log("fuzzed %d of %d total cases" % (self.total_mutant_index, self.total_num_mutations), 2)
            done_with_fuzz_node = False
            crash_count         = 0
            # loop through all possible mutations of the fuzz node.
            while not done_with_fuzz_node:
                if not self.fuzz_node.mutate():
                    self.log("all possible mutations for current fuzz node exhausted", 2)
                    done_with_fuzz_node = True
                    continue
                self.total_mutant_index += 1
                # if we don't need to skip the current test case.
                self.log("fuzzing %d of %d" % (self.fuzz_node.mutant_index, num_mutations), 2)
                while 1:
                    output = ""
                    for e in path:
                        node = self.nodes[e.src]
                        output += node.render()
                    output += self.fuzz_node.render()
                    break
                self.render_rest(self.fuzz_node, output)
            temp = self.nodes[edge.dst]
            self.fuzz(self.fuzz_node, path)
            temp.reset()

        # finished with the last node on the path, pop it off the path stack.
        if path:
            path.pop()

    def render_rest(self, this_node=None, output=""):
            original_output = output
            if(len(self.edges_from(this_node.id)) > 0):
                for edge in self.edges_from(this_node.id):
                    output = original_output
                    output += self.nodes[edge.dst].render()
                    self.render_rest(self.nodes[edge.dst], output)
            else:
                print output





def tobinary(n, bits):
    bStr=''
    while bits:
            bStr = str(n%2) + bStr
            n = n >> 1
	    bits = bits - 1
    return bStr


#
# 7 bit encoding
#
def toint(str):
	ret = 0
	strlen = len(str)
	for i in range(0,strlen):
		if(str[strlen-1-i]=='1'):
			ret = ret + (1<<i)
	return ret


def seven_bit_encoder(string):
	bitstream = ''
	ret = ''
	strlen = len(string)
	for i in range(0,strlen):
		bitstream += tobinary(ord(string[strlen-1-i]), 7)

	bitstream += '0'   # dunno why but seems like it does this for udh data...
	i = len(bitstream) - 8
	while (i > 0):
		dword = bitstream[i:i+8]
		temp = "%02x" % toint(dword)
		ret += temp.upper()
		i -= 8
	dword = bitstream[0:i+8]
        temp = "%02x" % toint(dword)
        ret += temp.upper()

	return ret

#
# 8 bit encoding
#
def eight_bit_encoder(string):
        ret = ''
        strlen = len(string)
        for i in range(0,strlen):
                temp = "%02x" % ord(string[i])
		ret += temp.upper()
	return ret

#
# 16 bit encoding
#
def sixteen_bit_encoder(string):
        ret = ''
        strlen = len(string)
        for i in range(0,strlen):
                temp = "00%02x" % ord(string[i])
                ret += temp.upper()
        return ret


# A PDU fuzzer
# ex: 079194710600403404 0D 91947196466656F8000090108211421540 0D D4 F2 9C 0E A2 97 E7 74 90 98 1D 06
# 07 [91 947106004034] 04 0D [91 94 71 96 46 66 56 F8] 00 00 90108211421540 0D 
# num octets              num digits (not inc 0d) [91 +4917696466658]     09/01/28 11:24:51 04   num septepts 
# 16 bit one: 
#0791947106004034040D91947196466656F8000890108211421540180048006F0077002000610072006500200079006F0075003F
# multi-part
#07 91 893905004200 C4 0C 91 893946759373 00 00 80802101802149 A0 05 0003000301 90E9311AB40ECF41E1397A9D0689C3F270BE0C6A8741EEB03CBD46D341E8B01CB42E83C461503B0C12D7C9A0B01ED40E83DAE9F35B9E5EA3E9A0213AEC2683E4757D7A4E07ADCB2074981D6E83C86972D89D9ED341C830BB0C6A87DDA0B01E9476BF41613708FE96CFD3E4B03B3DA7838E6134481C9683E4F57C19A40FB7D36E90FECD06B5D3
#07919471173254F6440C9194716720950800049930925161958067060504000000003427887983453455434532311212356564546ABEDF23432432234ABCAE45F9F32E44015EA2CB72032AEDE04010E0A40C1FF0FF011812000000AAAA414141414144141414424242424242BBBBBBBBBBCCCC111122218181818181818181818181

#07919471173254F6440C91947167209508000499309251619580 65 04 01 02 0020
#07919471173254F6440C91947167209508000499309251619580 03 04 01 02 0020 D06536FB8D2EB3D96F

# VVM URL:07916163838450F8440A80010000000041009040032071640076 06 05 04 15    7B00006136DB4DC787C7E4794CE60AD3E9F7B4BCCC 2ECFE72E7799AEABD160B09FB90733D97B3418CCD4EED966B6592E47BBE5622678CF34EFD568B39989DEA3E96C33DB2C97A3DD72315D50977493F341E8CCA66BCF6131DD989D2EBBE93A9A2D769B01
#                                                            msg udh bt size

s_initialize("query")
s_string("07919471173254F6440C91947167209508000499309251619580", fuzzable=False)


s_size("message", format="oct", length=1, math=lambda x: (x / 2), fuzzable=True)
if s_block_start("message"):
	s_size("udh", format="oct", length=1, math=lambda x: (x / 2), fuzzable=True)
	if s_block_start("udh"):
		s_byte(0x01, format="oct", full_range=True, fuzzable=True)
		s_size("data", format="oct", length=1, math=lambda x: x/2, fuzzable=True)
		if s_block_start("data", encoder=eight_bit_encoder):
			s_string("\x00\x20", max_len = 128, fuzzable=True)
		s_block_end()
	s_block_end()
	if s_block_start("text", encoder=eight_bit_encoder):
		s_string("hellohello", max_len = 128, fuzzable=True)
	s_block_end()
s_block_end()


fuzz_file = session_file()
fuzz_file.connect(s_get("query"))
fuzz_file.fuzz()

